#include "bug.h"

#define PTHREAD

#ifdef PTHREAD
#include <pthread.h>
#endif

CProxy_B bProxy;

class A : public CBase_A
{
private:
  int _id;
public:
  A(int i) : _id(i){
	 CkPrintf("[A-%d] created\n", _id);
  }
  void foo() { 
	 CkPrintf("[A-%d] foo called\n", _id);
	 bProxy.done();
  }
};

void* _invoke_foo(void* arg) {
  CProxy_A* a = (CProxy_A*) arg;
  a->foo();
  return NULL;
}


class B : public CBase_B {
private:
  int cnt;

public:
  B() {}
  void doit() {

	 CProxy_A a1 = CProxy_A::ckNew(1);
	 CProxy_A a2 = CProxy_A::ckNew(2);
	 cnt=2;

#ifdef PTHREAD
	 CkPrintf("[Main] creating threads...\n");
	 pthread_t tid1;
	 pthread_t tid2;

	 pthread_create(&tid1, NULL, _invoke_foo, (void*) &a1);
	 pthread_create(&tid1, NULL, _invoke_foo, (void*) &a2);

	 void *res;
	 pthread_join(tid1, &res);
	 pthread_join(tid2, &res);
#else
	 CkPrintf("[Main] simple calls...\n");
	 a1.foo();
	 a2.foo();
#endif
  }

  void done() {
	 if (--cnt==0) {
		CkPrintf("[Main] All done\n");
		CkExit();
	 }
  }
};

class main : public Chare
{
public:
  main(CkArgMsg *m) {
	 CkPrintf("[Main] main...\n");
	 bProxy = CProxy_B::ckNew();
	 bProxy.doit();

	 CkPrintf("[Main] main... done\n");
  }
};



#include "bug.def.h"
